package com.fp.persistence.pcustomer.company;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import com.fp.dto.hb.Log;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TCUSTAPPRAISER
 */
@Entity(name = "TcustAppraiser")
@Table(name = "TCUSTAPPRAISER")
public class TcustAppraiser extends com.fp.dto.AbstractDataTransport implements
        Serializable, HibernateBean, Cloneable, Log {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;
    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;
    /**
     * Clave primaria de la Entidad TcustAppraiser
     */
    @EmbeddedId
    private TcustAppraiserKey pk;

    /**
     * Contructor por defecto
     */
    public TcustAppraiser() {
    }

    /**
     * Contructor de TcustAppraiser
     *
     * @param pPk Clave Primaria del entity
     */
    public TcustAppraiser(TcustAppraiserKey pPk) {
        this();
        pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     *
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TcustAppraiser
     */
    public static TcustAppraiser find(EntityManager pEntityManager, TcustAppraiserKey pKey) throws Exception {
        TcustAppraiser obj = pEntityManager.find(TcustAppraiser.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TcustAppraiser
     *
     * @return El objeto que referencia a la Clave primaria de TcustAppraiser
     */
    public TcustAppraiserKey getPk() {
        return pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TcustAppraiser
     *
     * @param pPk El objeto que referencia a la nueva Clave primaria de
     * TcustAppraiser
     */
    public void setPk(TcustAppraiserKey pPk) {
        pk = pPk;
    }

    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TcustAppraiser)) {
            return false;
        }
        TcustAppraiser that = (TcustAppraiser) rhs;
        if (this.getPk() == null || that.getPk() == null) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementación del metodo hashCode de la la entidad TcustAppraiser
     *
     * @return el hashCode la instancia
     */
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementación toString
     */
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementación de la creación de un bean en blanco TcustAppraiser
     */
    public Object createInstance() {
        TcustAppraiser instance = new TcustAppraiser();
        instance.setPk(new TcustAppraiserKey());
        return instance;
    }

    /**
     * Clona la entidad TcustAppraiser
     *
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    public Object cloneMe() throws CloneNotSupportedException {
        TcustAppraiser p = (TcustAppraiser) this.clone();
        p.setPk((TcustAppraiserKey) this.pk.cloneMe());
        return p;
    }
}
